package consume

import (
	"applet/app/cfg"
	"applet/app/db"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/EggPlanet/egg_models.git/src/model"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git/rule/egg_energy"
	md2 "code.fnuoos.com/EggPlanet/egg_system_rules.git/rule/egg_energy/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"

	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
	"time"
)

func AdvertisingSmashConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>JpushRecordConsume>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	egg_system_rules.Init(cfg.RedisAddr)
	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			err = handleAdvertisingSmashConsume(res.Body)
			err = res.Ack(true)
			fmt.Println("err ::: ", err)
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleAdvertisingSmashConsume(msgData []byte) error {
	time.Sleep(time.Duration(100) * time.Millisecond) //休眠100毫秒
	// 1.解析mq中queue的数据结构体
	var msg *md.AdvertisingWatch
	err := json.Unmarshal(msgData, &msg)
	if err != nil {
		return err
	}
	var data model.AdvertisingCallback
	db.Db.Where("id=? ", msg.Id).Get(&data)
	if data.Id == 0 {
		return errors.New("记录不存在")
	}
	if data.IsRun == 1 {
		return nil
	}
	req := md2.HomePageWatchOverAdReq{UID: int64(data.Uid)}
	err = egg_energy.HomePageWatchOverAd(db.Db, req)
	if err != nil {
		return err
	}
	data.IsRun = 1
	db.Db.Where("id=?", data.Id).Cols("is_run").Update(&data)
	return nil
}
