package consume

import (
	"applet/app/cfg"
	"applet/app/db"

	utils2 "applet/app/utils"
	"applet/app/utils/cache"
	"applet/app/utils/logx"
	"applet/consume/md"
	"code.fnuoos.com/EggPlanet/egg_models.git/src/implement"
	"code.fnuoos.com/EggPlanet/egg_models.git/src/model"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git"
	"code.fnuoos.com/EggPlanet/egg_system_rules.git/aliyun"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/streadway/amqp"
	"time"
)

func AliyunSmsRecordConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>AliyunSmsRecordConsume>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()
	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	egg_system_rules.Init(cfg.RedisAddr)
	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			err = handleAliyunSmsRecordConsume(res.Body)
			if err != nil {
				fmt.Println("AliyunSmsRecordConsume_ERR:::::", err.Error())
				utils2.FilePutContents("AliyunSmsRecordConsume_ERR", utils2.SerializeStr(map[string]interface{}{
					"body": res.Body,
					"err":  err.Error(),
				}))
				_ = res.Reject(false)
				//TODO::重新推回队列末尾，避免造成队列堵塞
				var msg *md.JpushRecordFundData
				json.Unmarshal(res.Body, &msg)
				ch.Publish(queue.ExchangeName, msg, queue.RoutKey)
			} else {
				//_ = res.Reject(false)
				err = res.Ack(true)
			}

			fmt.Println("err ::: ", err)
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleAliyunSmsRecordConsume(msgData []byte) error {
	time.Sleep(time.Duration(100) * time.Millisecond) //休眠100毫秒
	// 1.解析mq中queue的数据结构体
	var msg *md.AliyunSmsRecordFundData
	err := json.Unmarshal(msgData, &msg)
	if err != nil {
		return err
	}
	engine := db.Db
	redisConn := cache.GetPool().Get()
	sysCfgDb := implement.NewSysCfgDb(engine, redisConn)
	aliyunSmsId := sysCfgDb.SysCfgGetWithDb("aliyun_sms_id")
	aliyunSmsSecret := sysCfgDb.SysCfgGetWithDb("aliyun_sms_secret")
	aliyunSmsSignName := sysCfgDb.SysCfgGetWithDb("aliyun_sms_sign_name")
	aliyunSmsSaleCode := sysCfgDb.SysCfgGetWithDb("aliyun_sms_sale_code")
	extra := "{\"content\":\"" + msg.Content + "\"}"
	if msg.Code != "" {
		aliyunSmsSaleCode = msg.Code
		extra = msg.Extra
	}
	err = aliyun.AliyunSendSms(aliyunSmsId, aliyunSmsSecret, msg.Phone, aliyunSmsSignName, aliyunSmsSaleCode, extra)
	if err != nil {
		return err
	}
	if msg.Id != "" {
		engine.Where("id=?", msg.Id).Cols("state").Update(&model.AliyunSmsRecord{State: 1})
	}
	return nil
}
